import math
import numpy as np
import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt



class sigmoid_function(object):
    
    def __init__(self,x_min,x_max,y_min,y_max,pitch_curve,resolution):
        #Load configuration
        self.x_min=x_min
        self.x_max=x_max
        self.y_min=y_min
        self.y_max=y_max
        self.pitch_curve=pitch_curve
        self.resolution=resolution

    def get_sigmoid_value(self,x_val):
        #Get single value
        x0=(self.x_max+self.x_min)/2

        return self.y_min+(self.y_max-self.y_min) / (1.0 + np.exp(-1.0 * self.pitch_curve*(x_val-x0)))

    
    def plot_curve(self):
        x=np.linspace(self.x_min,self.x_max,(self.x_max-self.x_min)/self.resolution+1)
        y=[]
        for i in x:
            y.append(self.get_sigmoid_value(i))        
        plt.plot(x,y)
        plt.savefig("test.png")

class plots():     
    def write_gnu_file(self,filename,matrix,format):
        
        #print matrix
        import numpy as np
        tp=np.matrix.transpose(np.array(matrix))
        np.savetxt(filename, tp,format)
        
    def print_matrix(self,m):
        dim=m.shape
        tmp=""
        for i in range(dim[0]):
            for j in range(dim[1]):
                tmp+="%.3f\t"% m[i,j]
            tmp+="\n"
        return tmp
        
        
class translate_ref():
    
    def local_to_global(self,ref,vector):
        
        #print ref
        alpha=ref[2]
#         print d_alpha_gl
        #Transformation-matrix (Local to global)
        T= np.matrix([[math.cos(alpha), -math.sin(alpha),0],
                      [math.sin(alpha), math.cos(alpha),0],
                      [0,0,1]])
        #Displacement in the global system
        #du_glob=T*cos        
        return ref+T*vector
                    
                    
    def global_to_local(self,ref,vector,mode=False):

        alpha=-ref[2]
        #Transformation-matrix (Global to local)
        T= np.matrix([[math.cos(alpha), -math.sin(alpha),0],
                      [math.sin(alpha), math.cos(alpha),0],
                      [0,0,1]])
        #Local system
        if mode=="rotate":
            return T*(vector) 
        else:
            return T*(vector-ref)     
    
    
    
    