#!/usr/bin/python
######
#Front=Left
#Back=Right

import time
import RPi.GPIO as GPIO
import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt


def measure_us(trigger,echo):    
    #Send signal
    GPIO.output(trigger, True)    
    #Sleep to settle
    time.sleep(0.001)
    #Stop signal
    GPIO.output(trigger, False)
    #Start time    
    start = time.time()
    #Measure the length of echo
    while GPIO.input(echo)==0:
        start = time.time()
    
    while GPIO.input(echo)==1:
        stop = time.time()
        
    return stop-start

#Script
#Board mode
GPIO.setmode(GPIO.BOARD)
# Pins
# Left sensor
trigger_left = 35
echo_left = 38
#Right sensor 
trigger_right = 37
echo_right = 40

# Set pins as output and input
GPIO.setup(trigger_left,GPIO.OUT)  # Trigger
GPIO.setup(trigger_right,GPIO.OUT)  # Trigger
GPIO.setup(echo_left,GPIO.IN)      # Echo
GPIO.setup(echo_right,GPIO.IN)      # Echo

#Measurement in loop



t_measured=[]
arr_distance_left=[]
arr_distance_right=[]
i=0
while True:
    # Set trigger to False (Low)
    GPIO.output(trigger_left, False)
    GPIO.output(trigger_right, False)
    # Allow module to settle
    
    # Calculate pulse length
    elapsed_left = measure_us(trigger_left,echo_left)
    elapsed_right = measure_us(trigger_right,echo_right)
    # Distance pulse travelled in that time is time
    # multiplied by the speed of sound (cm/s)
    distance_left = elapsed_left*34320/2
    distance_right=elapsed_right*34320/2
    
    
    print "Front: %f.1 Back: %f.1" % (distance_left,distance_right)
    
    if False:
        if i==0:        
            first_time=time.time()
            t_measured.append(0)
        else:
            t_measured.append(time.time()-first_time)
            
        
        arr_distance_left.append(distance_left)
        arr_distance_right.append(distance_right)
        
        
        #Static correlation
    #     distance_left=distance_left-0
    #     distance_right=distance_right-0
        
        
        if i>20:
            break
        i=i+1
        
    time.sleep(0.1)
# Reset GPIO settings
GPIO.cleanup()


#Plots

# plt.plot(t_measured, arr_distance_right)
# plt.plot(t_measured, arr_distance_left)
# plt.xlabel('Time [s]')
# plt.ylabel('Distance left (cm)')
# plt.title('Distance')
# plt.savefig("test.png")
# #plt.show()
