#!/usr/bin/python

import smbus
import math
import os,sys
from datetime import datetime
import scipy
import numpy as np
from scipy.signal import butter, lfilter, freqz

sys.path.append("../lib/")
#Import compass library
import l_drive


class mpu6050:
    
    def __init__(self):
        self.bus = smbus.SMBus(1) # or bus = smbus.SMBus(1) for Revision 2 boards
        self.port = 0x68       # This is the address value read via the i2cdetect command

    def wakeup(self):    
        self.bus.write_byte_data(self.port, 0x6b, 0)
        
    def read_byte(self,adr):
        return self.bus.read_byte_data(self.port, adr)
    
    def read_word(self,adr):
        high = self.bus.read_byte_data(self.port, adr)
        low = self.bus.read_byte_data(self.port, adr+1)
        val = (high << 8) + low
        return val
    
    def read_word_2c(self,adr):
        val = self.read_word(adr)
        if (val >= 0x8000):
            return -((65535 - val) + 1)
        else:
            return val
    

############################################################

mpu=mpu6050()
mpu.wakeup()
while True:
    
    gyro_xout = mpu.read_word_2c(0x43)
    gyro_yout = mpu.read_word_2c(0x45)
    gyro_zout = mpu.read_word_2c(0x47)
    
    gx= gyro_xout/ 131
    gy= gyro_yout/ 131
    gz= gyro_zout/ 131
    
    print "Um x: %.2f \tUm y: %.2f \tUm z: %.2f \t"%(gx,gy,gz)
#     accel_xout = mpu.read_word_2c(0x3b)
#     accel_yout = mpu.read_word_2c(0x3d)
#     accel_zout = mpu.read_word_2c(0x3f)
#      
#     accel_xout_scaled = accel_xout / 16384.0 *g
#     accel_yout_scaled = accel_yout / 16384.0 *g
#     accel_zout_scaled = accel_zout / 16384.0 *g
     
    #print "ax: %.6f \tay: %.6f \taz: %.6f" %(accel_xout_scaled,accel_yout_scaled,accel_zout_scaled)
     


################################################################################
# def write_gnu_file(filename,x,y):
#     
#     hash="#X\tY\n"
#     for i in range(len(x)):
#         hash=hash+"%.3f\t%.3f\n"%(x[i],y[i])
#     gnufile= open(filename,"w")
#     gnufile.write(hash)
#     
# 
# drive=l_drive.drive()
# mpu=mpu6050()
# mpu.wakeup()
# 
# g=9.807
# 
# 
# pre_settle=1
# break_time=pre_settle+1
# after_break_time=break_time+1
# t0=datetime.now()
# x0=0
# v0=0
# a0=0
# t=[]
# x=[x0]
# v=[v0]
# a=[]     
# 
# cal_ax=-0.0065
# while True:
#             
#     now=datetime.now()
#     
# 
#     #print tx
#     accel_xout = mpu.read_word_2c(0x3b)
#     accel_yout = mpu.read_word_2c(0x3d)
#     accel_zout = mpu.read_word_2c(0x3f)
#     
#     accel_xout_scaled = (accel_xout / 16384.0 *g)+cal_ax
#     accel_yout_scaled = accel_yout / 16384.0 *g
#     accel_zout_scaled = accel_zout / 16384.0 *g
#     
#     delta=now-t0
#     tx=delta.seconds + delta.microseconds/1E6
#     print "ax: %.6f \tay: %.6f \taz: %.6f" %(accel_xout_scaled,accel_yout_scaled,accel_zout_scaled)
# 
#     if True:                 
#         ax=accel_xout_scaled
#         #print ax
#         
#         t.append(tx)
#         a.append(ax)
#     if tx>break_time and tx<after_break_time:
#         drive.break_move()
#         pass
#     elif tx>after_break_time:
#         break
#     elif tx>pre_settle:
#         drive.move_fw(100,0)
#         pass
#     
# 
# 
# # Filter requirements.
# def butter_lowpass(cutoff, fs, order=5):
#     nyq = 0.5 * fs
#     normal_cutoff = cutoff / nyq
#     b, a = butter(order, normal_cutoff, btype='low', analog=False)
#     return b, a
# 
# def butter_lowpass_filter(data, cutoff, fs, order=5):
#     b, a = butter_lowpass(cutoff, fs, order=order)
#     y = lfilter(b, a, data)
#     return y
# order = 6
# fs = 300.0       # sample rate, Hz
# cutoff = 3.667  # desired cutoff frequency of the filter, Hz
# 
# y = butter_lowpass_filter(a, cutoff, fs, order)
# 
# write_gnu_file("acc.dat", t, y)
# os.system("gnuplot -persist -e \"plot  'acc.dat' with lines using 1:2 ;pause -1\"")
        
