#!/usr/bin/python
import pygame
import RPi.GPIO as GPIO
import time

#Board layout
GPIO.setmode(GPIO.BOARD)

#Right motor pins
motor_right_bw=12
motor_right_fw=11
motor_right_pwm=16

#Left motor pins
motor_left_bw=15
motor_left_fw=13
motor_left_pwm=18

#Define the pins
#Right motor
GPIO.setup(motor_right_fw, GPIO.OUT)
GPIO.setup(motor_right_bw, GPIO.OUT)
GPIO.setup(motor_right_pwm, GPIO.OUT)
#Left motor
GPIO.setup(motor_left_fw, GPIO.OUT)
GPIO.setup(motor_left_bw, GPIO.OUT)
GPIO.setup(motor_left_pwm, GPIO.OUT)

#Both motors are off
GPIO.output(motor_right_fw, GPIO.LOW)
GPIO.output(motor_right_bw, GPIO.LOW)
GPIO.output(motor_left_fw, GPIO.LOW)
GPIO.output(motor_left_bw, GPIO.LOW)

p_left = GPIO.PWM(motor_left_pwm, 50)
p_right = GPIO.PWM(motor_right_pwm, 50)


straight_duty=60
turn_duty=60

v_left=straight_duty
v_right=straight_duty
turn_sensitivity=60



def move_fw_start():
    global v_left,v_right
    
    GPIO.output(motor_left_fw, GPIO.HIGH)
    GPIO.output(motor_right_fw, GPIO.HIGH)
    
    print "GPIO is high"

    p_left.start(v_left)
    p_right.start(v_right)

def move_fw_end():
    
    p_left.stop()
    p_right.stop()
    GPIO.output(motor_left_fw, GPIO.LOW)
    GPIO.output(motor_right_fw, GPIO.LOW)
    
def move_bw_start():
    global v_left,v_right
    
    GPIO.output(motor_left_bw, GPIO.HIGH)
    GPIO.output(motor_right_bw, GPIO.HIGH)
    
    print "GPIO is high"

    p_left.start(v_left)
    p_right.start(v_right)
    
    
def move_bw_end():
    global v_left,v_right
    
    p_left.stop()
    p_right.stop()
    
    GPIO.output(motor_left_bw, GPIO.LOW)
    GPIO.output(motor_right_bw, GPIO.LOW)

    
    
    
def turn_right_start():
    global v_left,v_right,turn_sensitivity
    
    p_right.ChangeDutyCycle(v_right-turn_sensitivity)
    
def turn_right_end():
    global v_left,v_right
    
    p_right.ChangeDutyCycle(v_right)   
    
def turn_left_start():
    global v_left,v_right,turn_sensitivity
    
    p_left.ChangeDutyCycle(v_left-turn_sensitivity)
    
def turn_left_end():
    global v_left,v_right
    
    p_left.ChangeDutyCycle(v_left)   
    


def terminate():
    print "Terminating.."
    GPIO.cleanup()
    sys.exit()
    
    
#Controling
pygame.init()
screen = pygame.display.set_mode((640, 480))

while 1:
    for event in pygame.event.get() :
        #Pressed down
        if event.type == pygame.KEYDOWN :
            if event.key == pygame.K_UP :
                print "Up key pressed down."
                move_fw_start()
            elif event.key == pygame.K_DOWN :
                print "Down key pressed down."
                move_bw_start()
            elif event.key == pygame.K_RIGHT :
                print "Right key pressed down."
                turn_right_start()
            elif event.key == pygame.K_LEFT :
                print "Left key pressed down."
                turn_left_start()
            elif event.key == pygame.K_c :
                print "c key pressed down."
                terminate()
        elif event.type == pygame.KEYUP :
            if event.key == pygame.K_UP :
                print "Up key released."
                move_fw_end()
            elif event.key == pygame.K_DOWN :
                print "Down key released."
                move_bw_end()
            elif event.key == pygame.K_RIGHT :
                print "Right key released."
                turn_right_end()
            elif event.key == pygame.K_LEFT :
                print "Left key released."
                turn_left_end()